diff -r -c bash-1_14_7/subst.c bash1147/subst.c
*** bash-1_14_7/subst.c	Wed Mar 10 09:43:49 1999
--- bash1147/subst.c	Fri Mar 19 17:47:40 1999
***************
*** 24,29 ****
--- 24,32 ----
  #include <pwd.h>
  #include <signal.h>
  #include <errno.h>
+ #ifdef VMS
+ #include <wait.h>
+ #endif
  /* Not all systems declare ERRNO in errno.h... and some systems #define it! */
  #if !defined (errno)
  extern int errno;
***************
*** 52,57 ****
--- 55,64 ----
  #include <glob/fnmatch.h>
  #include "builtins/getopt.h"
  
+ #if defined (USE_VMS)
+ #include "vmsutil.h"
+ #endif
+ 
  /* The size that strings change by. */
  #define DEFAULT_ARRAY_SIZE 512
  
***************
*** 1036,1041 ****
--- 1043,1054 ----
  	     perform quoted null character removal on the current word. */
  	  remove_quoted_nulls (current_word);
  	  result = make_word_list (make_word (current_word), result);
+ #if defined (USE_VMS)
+ 	  /* expand each word */
+ 	  if ((!quoted && current_word[0] == '/')
+ 	      || (quoted && current_word[0] == CTLESC && current_word[1] == '/'))
+ 	    result->word->expansion = 1;
+ #endif
  	  if (quoted)
  	    result->word->quoted = 1;
  	}
***************
*** 1845,1850 ****
--- 1858,1890 ----
    nfifo = 0;
  }
  
+ #if defined (USE_VMS)
+ static char *
+ make_named_pipe ()
+ {
+   char *tmpdir;
+   char *tname;
+   int fd;
+ 
+   tmpdir = getenv ("TMPDIR");
+   if (tmpdir == NULL)
+     tmpdir = "/tmp";
+ 
+   tname = xmalloc (strlen (tmpdir) + sizeof ("/npXXXXXX"));
+   sprintf (tname, "%s/npXXXXXX", tmpdir);
+   tname = mktemp (vmsutil_expand_path (tname));
+   if ((fd = creat (tname, 0600)) < 0)
+     {
+       free (tname);
+       return ((char *)NULL);
+     }
+   else
+     close (fd);
+ 
+   add_fifo_list (tname);
+   return (tname);
+ }
+ #else /* !USE_VMS */
  static char *
  make_named_pipe ()
  {
***************
*** 1860,1865 ****
--- 1900,1906 ----
    add_fifo_list (tname);
    return (tname);
  }
+ #endif /* !USE_VMS */
  
  #if !defined (_POSIX_VERSION)
  int
***************
*** 1875,1880 ****
--- 1916,1931 ----
  }
  #endif /* !_POSIX_VERSION */
  
+ #if defined (VMS)
+ int
+ mkfifo (path, mode)
+      char *path;
+      int mode;
+ {
+   return (-1);
+ }
+ #endif
+ 
  #else /* HAVE_DEV_FD */
  
  /* DEV_FD_LIST is a bitmap of file descriptors attached to pipes the shell
***************
*** 1985,1990 ****
--- 2036,2044 ----
  #if defined (JOB_CONTROL)
    pid_t old_pipeline_pgrp;
  #endif  
+ #if defined (USE_VMS)
+   OLDENVBUF oldenvbuf;
+ #endif
  
    if (!string || !*string)
      return ((char *)NULL);
***************
*** 1992,1998 ****
--- 2046,2056 ----
  #if !defined (HAVE_DEV_FD)
    pathname = make_named_pipe ();
  #else /* HAVE_DEV_FD */
+ #if defined (USE_VMS)
+   if (vmsutil_pipe (fildes) < 0)
+ #else
    if (pipe (fildes) < 0)
+ #endif
      {
        internal_error ("can't make pipes for process substitution: %s",
  	strerror (errno));
***************
*** 2030,2041 ****
--- 2088,2108 ----
    stop_making_children ();
    pipeline_pgrp = old_pipeline_pgrp;
  #else /* !JOB_CONTROL */
+ #if defined (USE_VMS)
+   vmsutil_save_all_environment (&oldenvbuf);
+ #endif
    pid = make_child ((char *)NULL, 1);
+ #if defined (USE_VMS)
+   if (pid > 0)
+ #else
    if (pid == 0)
+ #endif
      {
+ #if !defined (USE_VMS)
        /* Cancel traps, in trap.c. */
        restore_original_signals ();
        setup_async_signals ();
+ #endif
        subshell_environment++;
      }
  #endif /* !JOB_CONTROL */
***************
*** 2049,2059 ****
--- 2116,2136 ----
        close (parent_pipe_fd);
        close (child_pipe_fd);
  #endif /* HAVE_DEV_FD */
+ #if defined (USE_VMS)
+       vmsutil_restore_all_environment (&oldenvbuf);
+ #endif
        return ((char *)NULL);
      }
  
+ #if defined (USE_VMS)
+   if (pid == 0)
+     {
+       /* parent side */
+       process_substitute_parent:
+ #else
    if (pid > 0)
      {
+ #endif
        last_made_pid = old_pid;
  
  #if defined (JOB_CONTROL) && defined (PGRP_PIPE)
***************
*** 2080,2086 ****
--- 2157,2168 ----
      {
        internal_error ("cannot open named pipe %s for %s: %s", pathname,
  	open_for_read_in_child ? "reading" : "writing", strerror (errno));
+ #if defined (USE_VMS)
+       vmsutil_wait_status = 127;
+       goto process_substitute_exit;
+ #else
        exit (127);
+ #endif
      }
  #else /* HAVE_DEV_FD */
    fd = child_pipe_fd;
***************
*** 2090,2096 ****
--- 2172,2183 ----
      {
        internal_error ("cannot duplicate named pipe %s as fd %d: %s",
  	pathname, open_for_read_in_child ? 0 : 1, strerror (errno));
+ #if defined (USE_VMS)
+       vmsutil_wait_status = 127;
+       goto process_substitute_exit;
+ #else
        exit (127);
+ #endif
      }
  
    close (fd);
***************
*** 2118,2125 ****
--- 2205,2222 ----
    close (open_for_read_in_child ? 0 : 1);
  #endif /* !HAVE_DEV_FD */
  
+ #if defined (USE_VMS)
+   vmsutil_wait_status = result;
+ 
+ process_substitute_exit:
+   vmsutil_restore_all_environment (&oldenvbuf);
+ 
+   /* run parent side */
+   goto process_substitute_parent;
+ #else
    exit (result);
    /*NOTREACHED*/
+ #endif
  }
  #endif /* PROCESS_SUBSTITUTION */
  
***************
*** 2135,2140 ****
--- 2232,2241 ----
    char *istring = (char *)NULL;
    int istring_index, istring_size, c = 1;
    int result;
+ #if defined (USE_VMS)
+   int pipes = vmsutil_pipe_no ();
+   OLDENVBUF oldenvbuf;
+ #endif
  
    istring_index = istring_size = 0;
  
***************
*** 2144,2151 ****
--- 2245,2260 ----
      return ((char *)NULL);
  
    /* Pipe the output of executing STRING into the current shell. */
+ #if defined (USE_VMS)
+   if (vmsutil_pipe (fildes) < 0)
+ #else
    if (pipe (fildes) < 0)
+ #endif
      {
+ #if defined (USE_VMS)
+       fildes[0] = -1;
+       fildes[1] = -1;
+ #endif
        internal_error ("Can't make pipes for command substitution!");
        goto error_exit;
      }
***************
*** 2167,2178 ****
--- 2276,2292 ----
      pipeline_pgrp = old_pipeline_pgrp;
    }
  #else /* !JOB_CONTROL */
+ #if defined (USE_VMS)
+   vmsutil_save_all_environment (&oldenvbuf);
+ #endif
    pid = make_child ((char *)NULL, 0);
  
+ #if !defined (USE_VMS)
    if (pid == 0)
      /* Reset the signal handlers in the child, but don't free the
         trap strings. */
      reset_signal_handlers ();
+ #endif
  #endif /* !JOB_CONTROL */
  
    if (pid < 0)
***************
*** 2180,2193 ****
--- 2294,2329 ----
        internal_error ("Can't make a child for command substitution: %s",
  	strerror (errno));
      error_exit:
+ #if defined (USE_VMS)
+       vmsutil_restore_all_environment (&oldenvbuf);
+     error_exit_without_restore:
+ #endif
  
        FREE (istring);
+ #if defined (USE_VMS)
+       if (fildes[0] >= 0)
+ 	{
+ 	  close (fildes[0]);
+ 	  fildes[0] = -1;
+ 	}
+       if (fildes[1] >= 0)
+ 	{
+ 	  close (fildes[1]);
+ 	  fildes[1] = -1;
+ 	}
+       vmsutil_pipe_clean (pipes);
+ #else
        close (fildes[0]);
        close (fildes[1]);
+ #endif
        return ((char *)NULL);
      }
  
+ #if defined (USE_VMS)
+   if (pid > 0)
+ #else
    if (pid == 0)
+ #endif
      {
        set_sigint_handler ();	/* XXX */
  #if defined (JOB_CONTROL)
***************
*** 2198,2206 ****
--- 2334,2348 ----
  	  internal_error
  	    ("command_substitute: cannot duplicate pipe as fd 1: %s",
  	     strerror (errno));
+ #if defined (USE_VMS)
+ 	  vmsutil_wait_status = (EXECUTION_FAILURE);
+ 	  goto error_exit;
+ #else
  	  exit (EXECUTION_FAILURE);
+ #endif
  	}
  
+ #if !defined (USE_VMS)
        /* If standard output is closed in the parent shell
  	 (such as after `exec >&-'), file descriptor 1 will be
  	 the lowest available file descriptor, and end up in
***************
*** 2216,2221 ****
--- 2358,2364 ----
  	  (fildes[0] != fileno (stdout)) &&
  	  (fildes[0] != fileno (stderr)))
  	close (fildes[0]);
+ #endif
  
        /* The currently executing shell is not interactive. */
        interactive = 0;
***************
*** 2229,2258 ****
--- 2372,2435 ----
  	 so we don't go back up to main (). */
        result = setjmp (top_level);
  
+ #if defined (USE_VMS)
+       if (result == EXITPROG)
+ 	{
+ 	  vmsutil_wait_status = (last_command_exit_value) << 8;
+ 	  goto error_exit;
+ 	}
+       else if (result)
+ 	{
+ 	  vmsutil_wait_status = (EXECUTION_FAILURE);
+ 	  goto error_exit;
+ 	}
+       else
+ 	vmsutil_wait_status = (parse_and_execute (string, "command substitution", -1)) << 8;
+ 
+       vmsutil_restore_all_environment (&oldenvbuf);
+ 
+       /* run parent side */
+       goto command_substitute_parent;
+ #else /* !USE_VMS */
        if (result == EXITPROG)
  	exit (last_command_exit_value);
        else if (result)
  	exit (EXECUTION_FAILURE);
        else
  	exit (parse_and_execute (string, "command substitution", -1));
+ #endif /* !USE_VMS */
      }
    else
      {
        FILE *istream;
  
+ #if defined (USE_VMS)
+ command_substitute_parent:
+       /* reset file pointer */
+       lseek (fildes[0], 0, SEEK_SET);
+       istream = fdopen (fildes[0], "r");
+ #else
        istream = fdopen (fildes[0], "r");
+ #endif
  
  #if defined (JOB_CONTROL) && defined (PGRP_PIPE)
        close_pgrp_pipe ();
  #endif /* JOB_CONTROL && PGRP_PIPE */
  
        close (fildes[1]);
+ #if defined (USE_VMS)
+       fildes[1] = -1;
+ #endif
  
        if (!istream)
  	{
  	  internal_error ("Can't reopen pipe to command substitution (fd %d): %s",
  			fildes[0], strerror (errno));
+ #if defined (USE_VMS)
+ 	  goto error_exit_without_restore;
+ #else
  	  goto error_exit;
+ #endif
  	}
  
        /* Read the output of the command through the pipe. */
***************
*** 2283,2289 ****
--- 2460,2472 ----
  	}
  
        fclose (istream);
+ #if defined (USE_VMS)
+       /* fildes[0] closed by fclose */
+       fildes[0] = -1;
+       vmsutil_pipe_clean (pipes);
+ #else
        close (fildes[0]);
+ #endif
  
        last_command_exit_value = wait_for (pid);
        last_command_subst_pid = pid;
***************
*** 2305,2311 ****
--- 2488,2498 ----
        /* If we read no output, just return now and save ourselves some
  	 trouble. */
        if (istring_index == 0)
+ #if defined (USE_VMS)
+ 	goto error_exit_without_restore;
+ #else
  	goto error_exit;
+ #endif
  
        /* Strip trailing newlines from the output of the command. */
        if (quoted)
***************
*** 2684,2689 ****
--- 2871,2879 ----
    int number;			/* Temporary number value. */
    int t_index;			/* For calls to string_extract_xxx. */
    char *command_subst_result;	/* For calls to command_substitute (). */
+ #if defined (USE_VMS)
+   int need_expand_path = 0;
+ #endif
  
    istring[0] = '\0';
  
***************
*** 2797,2802 ****
--- 2987,2997 ----
  	      temp = itos (number);
  	    dollar_add_string:
  	      if (string[sindex]) sindex++;
+ #if defined (USE_VMS)
+ 	      if (temp && istring_index == 0
+ 		  && (temp[0] == '/' || (temp[0] == CTLESC && temp[1] == '/')))
+ 		need_expand_path = 1;
+ #endif
  
  	      /* Add TEMP to ISTRING. */
  	    add_string:
***************
*** 3270,3275 ****
--- 3465,3474 ----
  		if (var && !invisible_p (var) && value_cell (var))
  		  {
  		    temp = value_cell (var);
+ #if defined (USE_VMS)
+ 		    if (temp[0] == '/')
+ 		      need_expand_path = 1;
+ #endif
  		    temp = quoted && temp && *temp ? quote_string (temp)
  						   : quote_escapes (temp);
  		    free (name);
***************
*** 3308,3316 ****
--- 3507,3522 ----
  	  handle_command_substitution:
  	    command_subst_result = command_substitute (temp, quoted);
  
+ #if 0 /* unwind_frame_run_internal may have already freed temp. DBR. */
  	    FREE (temp);
+ #endif
  
  	    temp = command_subst_result;
+ #if defined (USE_VMS)
+ 	    if (temp && istring_index == 0
+ 		&& (temp[0] == '/' || (temp[0] == CTLESC && temp[1] == '/')))
+ 	      need_expand_path = 1;
+ #endif
  
  	    if (string[sindex])
  	      sindex++;
***************
*** 3362,3367 ****
--- 3568,3577 ----
  
  	    t_index = sindex;
  	    temp = string_extract_double_quoted (string, &sindex);
+ #if defined (USE_VMS)
+ 	    if (temp && istring_index == 0 && temp[0] == '/')
+ 	      need_expand_path = 1;
+ #endif
  
  	    /* If the quotes surrounded the entire string, then the
  	       whole word was quoted. */
***************
*** 3437,3442 ****
--- 3647,3656 ----
  	       as well), so we go directly to add_string. */
  	    if (tresult)
  	      {
+ #if defined (USE_VMS)
+ 		if (tresult->word->expansion)
+ 		  need_expand_path = 1;
+ #endif
  		if (tresult->next)
  		  {
  		    quote_list (tresult);
***************
*** 3527,3532 ****
--- 3741,3750 ----
  	    }
  
  	add_character:
+ #if defined (USE_VMS)
+ 	  if (istring_index == 0 && c == '/')
+ 	    need_expand_path = 1;
+ #endif
  	  if (istring_index + 1 >= istring_size)
  	    {
  	      while (istring_index + 1 >= istring_size)
***************
*** 3543,3548 ****
--- 3761,3792 ----
  
  finished_with_string:
  final_exit:
+ #if defined (USE_VMS)
+   if (need_expand_path != 0 && istring && strpbrk (istring, ":;") == NULL)
+     {
+       char tbuf[4] = { 0, 0, 0, 0, };
+       char *p = istring, *q = tbuf;
+       int i;
+ 
+       /* dequote 4 chars */
+       for (i = 0; i < 4; i++)
+ 	{
+ 	  if (*p == CTLESC)
+ 	    p++;
+ 	  if (*p == '\0')
+ 	    break;
+ 	  *q++ = *p++;
+ 	}
+ 
+       /* check whether it's option switch */
+       if (tbuf[0] != '/' || (tbuf[1] != '\0' && (tbuf[1] == '/' || tbuf[2] == '\0')
+ 			     && (tbuf[1] != '/' || !isalpha (tbuf[2])
+ 				 || (tbuf[3] != '/' && tbuf[3] != '\0'))))
+ 	need_expand_path = 0;
+     }
+   else
+     need_expand_path = 0;
+ #endif
    /* OK, we're ready to return.  If we have a quoted string, and
       quoted_dollar_at is not set, we do no splitting at all; otherwise
       we split on ' '.  The routines that call this will handle what to
***************
*** 3625,3630 ****
--- 3869,3877 ----
  	      temp_list = make_word_list (tword, (WORD_LIST *)NULL);
  	      tword->quoted = quoted || (quoted_state == WHOLLY_QUOTED);
  	      tword->assignment = word->assignment;
+ #if defined (USE_VMS)
+ 	      tword->expansion = need_expand_path;
+ #endif
  	    }
  	}
  
***************
*** 4497,4502 ****
--- 4744,4756 ----
  void sv_notify ();
  #endif
  
+ #if defined (USE_VMS)
+ void sv_path_expand (char *name);
+ void sv_path_separator (char *name);
+ void sv_path_slash (char *name);
+ void sv_sysroot (char *name);
+ #endif
+ 
  #define SET_INT_VAR(name, intvar)  intvar = find_variable (name) != 0
  
  struct name_and_function {
***************
*** 4549,4554 ****
--- 4803,4816 ----
    { "allow_null_glob_expansion", sv_allow_null_glob_expansion },
    { "noclobber", sv_noclobber },
    { "nolinks", sv_nolinks },
+ 
+ #if defined (USE_VMS)
+   { "PATH_EXPAND", sv_path_expand },
+   { "PATH_SEPARATOR", sv_path_separator },
+   { "PATH_SLASH", sv_path_slash },
+   { "SYSROOT", sv_sysroot },
+ #endif
+ 
    { (char *)0x00, (VFunction *)0x00 }
  };
  
***************
*** 4865,4867 ****
--- 5127,5209 ----
    posix_readline_initialize (posixly_correct);
  #endif /* READLINE */
  }
+ 
+ #if defined (USE_VMS)
+ void
+ sv_path_expand (char *name)
+ {
+   char *p;
+ 
+   p = get_string_value (name);
+   vmsutil_path_expand = 0;
+   if (p != NULL)
+     {
+       if (*p == 'y' || *p == 'Y')
+ 	vmsutil_path_expand = 1;
+     }
+ }
+ 
+ void
+ sv_path_separator (char *name)
+ {
+   char **vp, *p;
+ 
+   vp = vmsutil_get_import_variables ();
+   p = get_string_value (name);
+   vmsutil_path_separator = ';';
+   if (p != NULL)
+     {
+       if (*p != '\0' && *p != '/' && *p != '\\' && *p < 0x7f)
+ 	vmsutil_path_separator = (int) *(unsigned char *) p;
+     }
+   vmsutil_put_export_variables (vp);
+ }
+ 
+ void
+ sv_path_slash (char *name)
+ {
+   char **vp, *p;
+ 
+   vp = vmsutil_get_import_variables ();
+   p = get_string_value (name);
+   vmsutil_path_slash = '/';
+   if (p != NULL)
+     {
+       if (*p != '\0' && (*p == '/' || *p == '\\') && *p < 0x7f)
+ 	vmsutil_path_slash = (int) *(unsigned char *) p;
+     }
+   vmsutil_put_export_variables (vp);
+ }
+ 
+ void
+ sv_sysroot (char *name)
+ {
+   char **vp, *p;
+ 
+   vp = vmsutil_get_import_variables ();
+   p = get_string_value (name);
+   if (p != NULL)
+     {
+       if (p[0] == '/' && p[1] == '/' && isalpha (p[2]) && (p[3] == '\0' || p[3] == '/'))
+ 	{
+ 	  vmsutil_sysroot[0] = p[2];
+ 	  vmsutil_sysroot[1] = ':';
+ 	  strcpy (vmsutil_sysroot + 2, p + 3);
+ 	}
+       else
+ 	strcpy (vmsutil_sysroot, p);
+       vmsutil_toslash (vmsutil_sysroot);
+       if (vmsutil_sysroot[0] != '/' || vmsutil_sysroot[1] != '\0')
+ 	vmsutil_delslash (vmsutil_sysroot);
+       if (isalpha (vmsutil_sysroot[0]) && vmsutil_sysroot[1] == ':')
+ 	vmsutil_sysroot[0] = tolower (vmsutil_sysroot[0]);
+       vmsutil_sysroot_len = strlen (vmsutil_sysroot);
+     }
+   else
+     {
+       vmsutil_sysroot[0] = '\0';
+       vmsutil_sysroot_len = -1;
+     }
+   vmsutil_put_export_variables (vp);
+ }
+ #endif
diff -r -c bash-1_14_7/support/getcppsyms.c bash1147/support/getcppsyms.c
*** bash-1_14_7/support/getcppsyms.c	Wed Mar 10 09:44:07 1999
--- bash1147/support/getcppsyms.c	Wed Mar 10 09:45:24 1999
***************
*** 422,427 ****
--- 422,430 ----
  #if defined (vax)
    printf (" -Dvax");
  #endif /* vax */
+ #if defined (vms)
+   printf (" -Dvms");
+ #endif /* vms */
  
    printf ("\n");
    exit (0);
diff -r -c bash-1_14_7/support/inpath. bash1147/support/inpath.
*** bash-1_14_7/support/inpath.	Wed Mar 10 09:44:07 1999
--- bash1147/support/inpath.	Wed Mar 10 09:45:24 1999
***************
*** 3,18 ****
  # Search $PATH for a file the same name as $1; return TRUE if found.
  #
  
  command=$1
  [ -n "$command" ] || exit 1
  
! set `echo $PATH | sed 's/^:/.:/
! 			s/::/:.:/g
! 			s/:$/:./
! 			s/:/ /g'`
  	
  while [ $# -ne 0 ] ; do
  	[ -f $1/$command ] && exit 0	# test -x not universal
  	shift
  done
  
--- 3,23 ----
  # Search $PATH for a file the same name as $1; return TRUE if found.
  #
  
+ PSC=$PATH_SEPARATOR
+ if [ -z "$PSC" ]; then
+   PSC=";"
+ fi
  command=$1
  [ -n "$command" ] || exit 1
  
! set `echo $PATH | sed -e "s/^$PSC/.$PSC/
! 			s/$PSC$PSC/$PSC.$PSC/g
! 			s/$PSC\\$/$PSC./
! 			s/$PSC/ /g" -e 's,\\\\,/,g'`
  	
  while [ $# -ne 0 ] ; do
  	[ -f $1/$command ] && exit 0	# test -x not universal
+ 	[ -f $1/${command}.exe ] && exit 0	# test -x not universal
  	shift
  done
  
diff -r -c bash-1_14_7/test.c bash1147/test.c
*** bash-1_14_7/test.c	Wed Mar 10 09:43:49 1999
--- bash1147/test.c	Fri Mar 19 17:36:16 1999
***************
*** 27,32 ****
--- 27,36 ----
  #include <stdio.h>
  #include "bashtypes.h"
  
+ #if defined (VMS)
+ #define lstat stat
+ #endif
+ 
  #if !defined (STANDALONE)
  #  if !defined (_POSIX_VERSION)
  #    include <sys/file.h>
***************
*** 47,52 ****
--- 51,60 ----
  #  define digit_value(c) ((c) - '0')
  #endif /* STANDALONE */
  
+ #if defined (USE_VMS)
+ #include <stdlib.h>
+ #endif
+ 
  #if !defined (STRLEN)
  #  define STRLEN(s) ((s)[0] ? ((s)[1] ? ((s)[2] ? strlen(s) : 2) : 1) : 0)
  #endif
***************
*** 191,197 ****
--- 199,217 ----
  	}
      }
  #endif /* !HAVE_DEV_FD */
+ #if defined (USE_VMS)
+   {
+     int rc;
+     char *fixp;
+ 
+     fixp = vmsutil_expand_path (savestring (path));
+     rc = stat (fixp, finfo);
+     free (fixp);
+     return rc;
+   }
+ #else
    return (stat (path, finfo));
+ #endif
  }
  
  /* Do the same thing access(2) does, but use the effective uid and gid,
***************
*** 773,778 ****
--- 793,822 ----
      case 'x':			/* File is executable? */
        unary_advance ();
        value = -1 != EACCESS (argv[pos - 1], X_OK);
+ #if defined (USE_VMS)
+       if (value != TRUE)
+ 	{
+ 	  char *name, *ext;
+ 	  int len;
+ 
+ 	  len = strlen (argv[pos - 1]);
+ 	  name = malloc (len + 5);
+ 	  if (name != NULL)
+ 	    {
+ 	      strcpy (name, argv[pos - 1]);
+ 	      ext = name + len;
+ #if defined (USE_VMS)
+ 	      while (vmsutil_add_executable_suffix (name, ext))
+ #endif
+ 		{
+ 		  value = -1 != EACCESS (name, X_OK);
+ 		  if (value == TRUE)
+ 		    break;
+ 		}
+ 	      free (name);
+ 	    }
+ 	}
+ #endif
        return (TRUE == value);
  
      case 'O':			/* File is owned by you? */
diff -r -c bash-1_14_7/tests/exp-tests. bash1147/tests/exp-tests.
*** bash-1_14_7/tests/exp-tests.	Wed Mar 10 09:44:08 1999
--- bash1147/tests/exp-tests.	Wed Mar 10 09:45:26 1999
***************
*** 18,35 ****
  # Test the substitution quoting characters (CTLESC and CTLNUL) in different
  # combinations
  
! expect "<^A>"
! recho `echo ''`
! expect "<^A>"
! recho `echo ""`
! expect "<^B>"
! recho `echo ''`
! expect "<^B>"
! recho `echo ""`
! expect "<^A>"
! recho `echo `
! expect "<^B>"
! recho `echo `
  
  # Test null strings without variable expansion
  expect "<abcdefgh>"
--- 18,35 ----
  # Test the substitution quoting characters (CTLESC and CTLNUL) in different
  # combinations
  
! #expect "<^A>"
! #recho `echo ''`
! #expect "<^A>"
! #recho `echo ""`
! #expect "<^B>"
! #recho `echo ''`
! #expect "<^B>"
! #recho `echo ""`
! #expect "<^A>"
! #recho `echo `
! #expect "<^B>"
! #recho `echo `
  
  # Test null strings without variable expansion
  expect "<abcdefgh>"
***************
*** 227,237 ****
  expect '<\$x>'
  recho '\$x'
  
! expect '<$x>'
! recho `echo '\$x'`
  
! expect '<\$x>'
! recho $(echo '\$x')
  
  # The difference between $* "$*" and "$@"
  
--- 227,237 ----
  expect '<\$x>'
  recho '\$x'
  
! #expect '<$x>'
! #recho `echo '\$x'`
  
! #expect '<\$x>'
! #recho $(echo '\$x')
  
  # The difference between $* "$*" and "$@"
  
***************
*** 316,323 ****
  expect '<26>'
  recho $[ 13 * 2 ]
  
! expect '<\>'
! recho `echo \\\\`
  
  expect '<~>'
  recho '~'
--- 316,323 ----
  expect '<26>'
  recho $[ 13 * 2 ]
  
! #expect '<\>'
! #recho `echo \\\\`
  
  expect '<~>'
  recho '~'
diff -r -c bash-1_14_7/tests/run-ifs-tests. bash1147/tests/run-ifs-tests.
*** bash-1_14_7/tests/run-ifs-tests.	Wed Mar 10 09:44:10 1999
--- bash1147/tests/run-ifs-tests.	Wed Mar 10 09:45:28 1999
***************
*** 2,13 ****
  # show that IFS is only applied to the result of expansions
  #
  ../bash ifs-test-1.sh > xx
! diff xx ./ifs.1.right
  
  ../bash ifs-test-2.sh > xx
! diff xx ./ifs.2.right
  
  ../bash ifs-test-3.sh > xx
! diff xx ./ifs.3.right
  
  rm -f xx
--- 2,13 ----
  # show that IFS is only applied to the result of expansions
  #
  ../bash ifs-test-1.sh > xx
! diff xx ./ifs_1.right
  
  ../bash ifs-test-2.sh > xx
! diff xx ./ifs_2.right
  
  ../bash ifs-test-3.sh > xx
! diff xx ./ifs_3.right
  
  rm -f xx
diff -r -c bash-1_14_7/tests/varenv.sh bash1147/tests/varenv.sh
*** bash-1_14_7/tests/varenv.sh	Wed Mar 10 09:44:11 1999
--- bash1147/tests/varenv.sh	Wed Mar 10 09:45:29 1999
***************
*** 45,51 ****
  echo $HOME
  
  expect $HOME
! HOME=/a/b/c /bin/echo $HOME
  
  expect $HOME
  echo $HOME
--- 45,51 ----
  echo $HOME
  
  expect $HOME
! HOME=/a/b/c /gnu/bin/echo $HOME
  
  expect $HOME
  echo $HOME
***************
*** 59,65 ****
  # This should echo $HOME 9, NOT /a/b/c 9
  
  expect "$HOME"
! HOME=/a/b/c /bin/echo $HOME c=9
  expect "$HOME 7"
  echo $HOME $c
  
--- 59,65 ----
  # This should echo $HOME 9, NOT /a/b/c 9
  
  expect "$HOME"
! HOME=/a/b/c /gnu/bin/echo $HOME c=9
  expect "$HOME 7"
  echo $HOME $c
  
diff -r -c bash-1_14_7/trap.c bash1147/trap.c
*** bash-1_14_7/trap.c	Wed Mar 10 09:43:49 1999
--- bash1147/trap.c	Fri Mar 19 17:36:16 1999
***************
*** 86,97 ****
--- 86,99 ----
        original_signals[i] = IMPOSSIBLE_TRAP_HANDLER;
      }
  
+ #if !defined (USE_VMS)
    /* Show which signals are treated specially by the shell. */
  #if defined (SIGCHLD)
    original_signals[SIGCHLD] = (SigHandler *) set_signal_handler (SIGCHLD, SIG_DFL);
    set_signal_handler (SIGCHLD, original_signals[SIGCHLD]);
    sigmodes[SIGCHLD] |= (SIG_SPECIAL | SIG_NO_TRAP);
  #endif /* SIGCHLD */
+ #endif /* !USE_VMS */
  
    original_signals[SIGINT] =
      (SigHandler *) set_signal_handler (SIGINT, SIG_DFL);
***************
*** 454,459 ****
--- 456,483 ----
  /* Handle the calling of "trap 0".  The only sticky situation is when
     the command to be executed includes an "exit".  This is why we have
     to provide our own place for top_level to jump to. */
+ #if defined (USE_VMS)
+ /* static variables wrapper */
+ int
+ vmsutil_get_signal_modes (int sig)
+ {
+   if (sig < 0 || sig >= NSIG)
+     return -1;
+   return sigmodes[sig];
+ }
+ 
+ int
+ vmsutil_set_signal_modes (int sig, int modes)
+ {
+   int oldmodes;
+   if (sig < 0 || sig >= NSIG)
+     return -1;
+   oldmodes = sigmodes[sig];
+   sigmodes[sig] = modes;
+   return oldmodes;
+ }
+ #endif
+ 
  int
  run_exit_trap ()
  {
***************
*** 586,591 ****
--- 610,619 ----
  {
    char *command, *saved_command;
    int old_exit_value;
+ #if defined (USE_VMS)
+   int old_subshell_exit_builtin;
+   extern int subshell_exit_builtin;
+ #endif
  
    /* Run the interrupt trap if SIGINT is trapped and not ignored, and if
       we are not currently running in the interrupt trap handler. */
***************
*** 601,608 ****
--- 629,643 ----
        command = savestring (saved_command);
  
        old_exit_value = last_command_exit_value;
+ #if defined (USE_VMS)
+       old_subshell_exit_builtin = subshell_exit_builtin; 
+       subshell_exit_builtin = 0;
+ #endif
        parse_and_execute (command, "interrupt trap", 0);
        last_command_exit_value = old_exit_value;
+ #if defined (USE_VMS)
+       subshell_exit_builtin = old_subshell_exit_builtin;
+ #endif
  
        sigmodes[SIGINT] &= ~SIG_INPROGRESS;
  
diff -r -c bash-1_14_7/trap.h bash1147/trap.h
*** bash-1_14_7/trap.h	Wed Mar 10 09:43:49 1999
--- bash1147/trap.h	Wed Mar 10 09:44:58 1999
***************
*** 29,35 ****
--- 29,39 ----
  #endif /* SIG_DFL */
  
  #if !defined (NSIG)
+ #if defined (SIGMAX)
+ #define NSIG SIGMAX
+ #else
  #define NSIG 64
+ #endif /* !SIGMAX */
  #endif /* !NSIG */
  
  #define NO_SIG -1
diff -r -c bash-1_14_7/variables.c bash1147/variables.c
*** bash-1_14_7/variables.c	Wed Mar 10 09:43:49 1999
--- bash1147/variables.c	Fri Mar 19 17:36:16 1999
***************
*** 195,201 ****
--- 195,211 ----
    temp_var = set_if_not ("PATH", DEFAULT_PATH_VALUE);
    set_auto_export (temp_var);
  
+ #if defined (USE_VMS)
+   temp_var = find_variable ("TERM");
+   if (!temp_var)
+     {
+       /* makes empty invisible variable */
+       temp_var = bind_variable ("TERM", (char *) NULL);
+       temp_var->attributes |= att_invisible;
+     }
+ #else
    temp_var = set_if_not ("TERM", "dumb");
+ #endif
    set_auto_export (temp_var);
  
    if (interactive_shell)
***************
*** 537,544 ****
--- 547,562 ----
    register SHELL_VAR *var;
  
    for (i = 0; list && (var = list[i]); i++)
+ #if defined (USE_VMS)
+     {
+       QUIT;
+       if (!invisible_p (var))
+         print_assignment (var);
+     }
+ #else
      if (!invisible_p (var))
        print_assignment (var);
+ #endif
  }
  
  #if defined (NOTDEF)
***************
*** 1666,1676 ****
--- 1684,1700 ----
  	{
  	  free (array[i]);
  	  array[i] = savestring (assign);
+ #if defined (USE_VMS)
+ 	  array[i] = vmsutil_fix_variable (array[i]);
+ #endif
  	  return (array);
  	}
      }
    array = (char **)xrealloc (array, ((2 + i) * sizeof (char *)));
    array[i++] = savestring (assign);
+ #if defined (USE_VMS)
+   array[i-1] = vmsutil_fix_variable (array[i-1]);
+ #endif
    array[i] = (char *)NULL;
    return (array);
  }
